function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
        var info = gen[key](arg);
        var value = info.value;
    } catch (error) {
        reject(error);
        return;
    }
    if (info.done) {
        resolve(value);
    } else {
        Promise.resolve(value).then(_next, _throw);
    }
}
function _asyncToGenerator(fn) {
    return function() {
        var self = this, args = arguments;
        return new Promise(function(resolve, reject) {
            var gen = fn.apply(self, args);
            function _next(value) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
            }
            function _throw(err) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
            }
            _next(undefined);
        });
    };
}
var __generator = this && this.__generator || function(thisArg, body) {
    var f, y, t, g, _ = {
        label: 0,
        sent: function() {
            if (t[0] & 1) throw t[1];
            return t[1];
        },
        trys: [],
        ops: []
    };
    return g = {
        next: verb(0),
        "throw": verb(1),
        "return": verb(2)
    }, typeof Symbol === "function" && (g[Symbol.iterator] = function() {
        return this;
    }), g;
    function verb(n) {
        return function(v) {
            return step([
                n,
                v
            ]);
        };
    }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while(_)try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [
                op[0] & 2,
                t.value
            ];
            switch(op[0]){
                case 0:
                case 1:
                    t = op;
                    break;
                case 4:
                    _.label++;
                    return {
                        value: op[1],
                        done: false
                    };
                case 5:
                    _.label++;
                    y = op[1];
                    op = [
                        0
                    ];
                    continue;
                case 7:
                    op = _.ops.pop();
                    _.trys.pop();
                    continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                        _ = 0;
                        continue;
                    }
                    if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
                        _.label = op[1];
                        break;
                    }
                    if (op[0] === 6 && _.label < t[1]) {
                        _.label = t[1];
                        t = op;
                        break;
                    }
                    if (t && _.label < t[2]) {
                        _.label = t[2];
                        _.ops.push(op);
                        break;
                    }
                    if (t[2]) _.ops.pop();
                    _.trys.pop();
                    continue;
            }
            op = body.call(thisArg, _);
        } catch (e) {
            op = [
                6,
                e
            ];
            y = 0;
        } finally{
            f = t = 0;
        }
        if (op[0] & 5) throw op[1];
        return {
            value: op[0] ? op[1] : void 0,
            done: true
        };
    }
};
import pc from "picocolors";
import chokidar from "chokidar";
import { existsSync } from "fs";
import { join, resolve, basename } from "path";
import { build } from "../lib/build.js";
import { printAndExit } from "../lib/utils/logger.js";
import { logBuildHelp } from "./helps.js";
import { clearCache } from "../lib/utils/require.js";
import { REQUIRED_SUBDIRS, TMP_REGEX, TEMPLATE_FOLDER, DATA_FOLDER } from "../lib/constants.js";
var doBuild = /*#__PURE__*/ _asyncToGenerator(function(dir, args, uncache) {
    var err;
    return __generator(this, function(_state) {
        switch(_state.label){
            case 0:
                if (uncache === void 0) uncache = false;
                if (uncache) {
                    clearCache(TMP_REGEX);
                }
                _state.label = 1;
            case 1:
                _state.trys.push([
                    1,
                    3,
                    ,
                    4
                ]);
                return [
                    4,
                    build(dir, args)
                ];
            case 2:
                _state.sent();
                return [
                    3,
                    4
                ];
            case 3:
                err = _state.sent();
                console.log(pc.red("⚠️ Error while building:\n"));
                console.error(err.stack);
                return [
                    2,
                    false
                ];
            case 4:
                console.log(pc.green("✨ Build complete!\n"));
                return [
                    2,
                    true
                ];
        }
    });
});
export var Build = /*#__PURE__*/ _asyncToGenerator(function(args) {
    var dir, verb;
    return __generator(this, function(_state) {
        switch(_state.label){
            case 0:
                if (args.help) {
                    logBuildHelp();
                    process.exit(0);
                }
                dir = resolve(args.path);
                verb = args.watch ? "Watching" : "Building";
                console.log(pc.blue("\uD83E\uDD86 " + verb + " decks in " + basename(dir) + "...\n"));
                // Check Dependencies
                if (!existsSync(dir)) {
                    printAndExit(pc.red("No such directory " + basename(dir) + "."));
                }
                REQUIRED_SUBDIRS.forEach(function(subdir) {
                    if (!existsSync(join(dir, subdir))) {
                        printAndExit(pc.red("Couldn't find " + subdir + ". Exiting."));
                    }
                });
                // Do initial build
                return [
                    4,
                    doBuild(dir, args)
                ];
            case 1:
                _state.sent();
                if (!args.watch) return [
                    3,
                    3
                ];
                return [
                    4,
                    new Promise(function(res, rej) {
                        var watcher = chokidar.watch([
                            resolve("./" + TEMPLATE_FOLDER + "/"),
                            resolve("./" + DATA_FOLDER + "/")
                        ], {
                            ignored: [
                                "node_modules",
                                /(^|[\/\\])\../
                            ],
                            ignoreInitial: true,
                            persistent: true,
                            awaitWriteFinish: {
                                stabilityThreshold: 50,
                                pollInterval: 10
                            }
                        });
                        // Handle new and modified files
                        watcher.on("add", /*#__PURE__*/ _asyncToGenerator(function() {
                            return __generator(this, function(_state) {
                                switch(_state.label){
                                    case 0:
                                        return [
                                            4,
                                            doBuild(dir, args, true)
                                        ];
                                    case 1:
                                        return [
                                            2,
                                            _state.sent()
                                        ];
                                }
                            });
                        }));
                        watcher.on("change", /*#__PURE__*/ _asyncToGenerator(function() {
                            return __generator(this, function(_state) {
                                switch(_state.label){
                                    case 0:
                                        return [
                                            4,
                                            doBuild(dir, args, true)
                                        ];
                                    case 1:
                                        return [
                                            2,
                                            _state.sent()
                                        ];
                                }
                            });
                        }));
                        // Handle removing files
                        watcher.on("unlink", /*#__PURE__*/ _asyncToGenerator(function(p) {
                            return __generator(this, function(_state) {
                                switch(_state.label){
                                    case 0:
                                        watcher.unwatch(p);
                                        return [
                                            4,
                                            doBuild(dir, args, true)
                                        ];
                                    case 1:
                                        _state.sent();
                                        return [
                                            2
                                        ];
                                }
                            });
                        }));
                        // Handle errors
                        watcher.on("error", function(error) {
                            console.log(pc.red(error));
                            rej(error);
                        });
                    })
                ];
            case 2:
                _state.sent();
                _state.label = 3;
            case 3:
                // Done
                process.exit(0);
                return [
                    2
                ];
        }
    });
});
