function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
        var info = gen[key](arg);
        var value = info.value;
    } catch (error) {
        reject(error);
        return;
    }
    if (info.done) {
        resolve(value);
    } else {
        Promise.resolve(value).then(_next, _throw);
    }
}
function _asyncToGenerator(fn) {
    return function() {
        var self = this, args = arguments;
        return new Promise(function(resolve, reject) {
            var gen = fn.apply(self, args);
            function _next(value) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
            }
            function _throw(err) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
            }
            _next(undefined);
        });
    };
}
var __generator = this && this.__generator || function(thisArg, body) {
    var f, y, t, g, _ = {
        label: 0,
        sent: function() {
            if (t[0] & 1) throw t[1];
            return t[1];
        },
        trys: [],
        ops: []
    };
    return g = {
        next: verb(0),
        "throw": verb(1),
        "return": verb(2)
    }, typeof Symbol === "function" && (g[Symbol.iterator] = function() {
        return this;
    }), g;
    function verb(n) {
        return function(v) {
            return step([
                n,
                v
            ]);
        };
    }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while(_)try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [
                op[0] & 2,
                t.value
            ];
            switch(op[0]){
                case 0:
                case 1:
                    t = op;
                    break;
                case 4:
                    _.label++;
                    return {
                        value: op[1],
                        done: false
                    };
                case 5:
                    _.label++;
                    y = op[1];
                    op = [
                        0
                    ];
                    continue;
                case 7:
                    op = _.ops.pop();
                    _.trys.pop();
                    continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                        _ = 0;
                        continue;
                    }
                    if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
                        _.label = op[1];
                        break;
                    }
                    if (op[0] === 6 && _.label < t[1]) {
                        _.label = t[1];
                        t = op;
                        break;
                    }
                    if (t && _.label < t[2]) {
                        _.label = t[2];
                        _.ops.push(op);
                        break;
                    }
                    if (t[2]) _.ops.pop();
                    _.trys.pop();
                    continue;
            }
            op = body.call(thisArg, _);
        } catch (e) {
            op = [
                6,
                e
            ];
            y = 0;
        } finally{
            f = t = 0;
        }
        if (op[0] & 5) throw op[1];
        return {
            value: op[0] ? op[1] : void 0,
            done: true
        };
    }
};
import path from "path";
import miss from "mississippi";
import puppeteer from "puppeteer";
import { cropStream } from "./streams/cropStream.js";
import { nullStream } from "./streams/nullStream.js";
import { pdfStream } from "./streams/pdfStream.js";
import { pngStream } from "./streams/pngStream.js";
import fsp from "./utils/fsp.js";
export var formatCards = /*#__PURE__*/ _asyncToGenerator(function(projectRoot, config, data, renderings) {
    var _tmp, _tmp1, _i, deckKey;
    return __generator(this, function(_state) {
        switch(_state.label){
            case 0:
                _tmp = [];
                for(_tmp1 in config)_tmp.push(_tmp1);
                _i = 0;
                _state.label = 1;
            case 1:
                if (!(_i < _tmp.length)) return [
                    3,
                    4
                ];
                deckKey = _tmp[_i];
                return [
                    4,
                    formatDeck(projectRoot, config[deckKey], renderings[deckKey], deckKey)
                ];
            case 2:
                _state.sent();
                _state.label = 3;
            case 3:
                _i++;
                return [
                    3,
                    1
                ];
            case 4:
                return [
                    2
                ];
        }
    });
});
var formatDeck = /*#__PURE__*/ _asyncToGenerator(function(projectRoot, config, renderings, deckKey) {
    var output, png, pdf, browser, page, size, renderingStream;
    return __generator(this, function(_state) {
        switch(_state.label){
            case 0:
                return [
                    4,
                    deckFolder(projectRoot, deckKey)
                ];
            case 1:
                output = _state.sent();
                png = config.format.includes("png");
                pdf = config.format.includes("pdf");
                return [
                    4,
                    puppeteer.launch()
                ];
            case 2:
                browser = _state.sent();
                return [
                    4,
                    browser.newPage()
                ];
            case 3:
                page = _state.sent();
                size = renderings.length;
                renderingStream = miss.from.obj(renderings);
                return [
                    4,
                    new Promise(function(res, rej) {
                        process.on("SIGINT", rej);
                        var finalize = /*#__PURE__*/ _asyncToGenerator(function(err) {
                            return __generator(this, function(_state) {
                                switch(_state.label){
                                    case 0:
                                        if (!browser) return [
                                            3,
                                            2
                                        ];
                                        return [
                                            4,
                                            browser.close()
                                        ];
                                    case 1:
                                        _state.sent();
                                        _state.label = 2;
                                    case 2:
                                        if (err) rej(err);
                                        res();
                                        return [
                                            2
                                        ];
                                }
                            });
                        });
                        if ((png || pdf) && page) {
                            renderingStream = renderingStream.pipe(pngStream({
                                output: output,
                                page: page,
                                size: size,
                                deckKey: deckKey,
                                config: config
                            }));
                        }
                        if (pdf) {
                            renderingStream = renderingStream.pipe(cropStream({
                                config: config,
                                size: size,
                                deckKey: deckKey
                            })).pipe(pdfStream({
                                output: output,
                                config: config,
                                deckKey: deckKey
                            }));
                        }
                        renderingStream.pipe(nullStream()).on("error", finalize).on("end", finalize).on("finish", finalize);
                    })
                ];
            case 4:
                return [
                    2,
                    _state.sent()
                ];
        }
    });
});
var deckFolder = /*#__PURE__*/ _asyncToGenerator(function(projectRoot, deckKey) {
    var output, folder;
    return __generator(this, function(_state) {
        switch(_state.label){
            case 0:
                output = path.join(projectRoot, "output");
                folder = path.join(output, deckKey);
                return [
                    4,
                    fsp.exists(output)
                ];
            case 1:
                if (!!_state.sent()) return [
                    3,
                    3
                ];
                return [
                    4,
                    fsp.mkdir(output)
                ];
            case 2:
                _state.sent();
                _state.label = 3;
            case 3:
                return [
                    4,
                    fsp.exists(folder)
                ];
            case 4:
                if (!!_state.sent()) return [
                    3,
                    6
                ];
                return [
                    4,
                    fsp.mkdir(folder)
                ];
            case 5:
                _state.sent();
                _state.label = 6;
            case 6:
                return [
                    2,
                    folder
                ];
        }
    });
});
