function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
        var info = gen[key](arg);
        var value = info.value;
    } catch (error) {
        reject(error);
        return;
    }
    if (info.done) {
        resolve(value);
    } else {
        Promise.resolve(value).then(_next, _throw);
    }
}
function _asyncToGenerator(fn) {
    return function() {
        var self = this, args = arguments;
        return new Promise(function(resolve, reject) {
            var gen = fn.apply(self, args);
            function _next(value) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
            }
            function _throw(err) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
            }
            _next(undefined);
        });
    };
}
var __generator = this && this.__generator || function(thisArg, body) {
    var f, y, t, g, _ = {
        label: 0,
        sent: function() {
            if (t[0] & 1) throw t[1];
            return t[1];
        },
        trys: [],
        ops: []
    };
    return g = {
        next: verb(0),
        "throw": verb(1),
        "return": verb(2)
    }, typeof Symbol === "function" && (g[Symbol.iterator] = function() {
        return this;
    }), g;
    function verb(n) {
        return function(v) {
            return step([
                n,
                v
            ]);
        };
    }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while(_)try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [
                op[0] & 2,
                t.value
            ];
            switch(op[0]){
                case 0:
                case 1:
                    t = op;
                    break;
                case 4:
                    _.label++;
                    return {
                        value: op[1],
                        done: false
                    };
                case 5:
                    _.label++;
                    y = op[1];
                    op = [
                        0
                    ];
                    continue;
                case 7:
                    op = _.ops.pop();
                    _.trys.pop();
                    continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                        _ = 0;
                        continue;
                    }
                    if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
                        _.label = op[1];
                        break;
                    }
                    if (op[0] === 6 && _.label < t[1]) {
                        _.label = t[1];
                        t = op;
                        break;
                    }
                    if (t && _.label < t[2]) {
                        _.label = t[2];
                        _.ops.push(op);
                        break;
                    }
                    if (t[2]) _.ops.pop();
                    _.trys.pop();
                    continue;
            }
            op = body.call(thisArg, _);
        } catch (e) {
            op = [
                6,
                e
            ];
            y = 0;
        } finally{
            f = t = 0;
        }
        if (op[0] & 5) throw op[1];
        return {
            value: op[0] ? op[1] : void 0,
            done: true
        };
    }
};
import fs from "fs";
import _ from "lodash";
import PDFDocument from "pdfkit";
import { pdfname } from "../utils/filenames.js";
import { insToPts, pxToPts } from "../utils/units.js";
export var formatPdf = /*#__PURE__*/ _asyncToGenerator(function(pngBuffers, out, config, deckKey) {
    var _config_pdf, _config_pdf_layout, layout, _config_pdf_size, size, _config_pdf_margin, margin, bleed, docConfig, doc, filename, cardWidthPx, cardHeightPx, marginPts, docWidth, docHeight, cardWidthPts, cardHeightPts, pageWidth, pageHeight, cardsPerRow, rowsPerPage, rows, pages, trimLines;
    return __generator(this, function(_state) {
        if (deckKey === void 0) deckKey = "";
        _config_pdf = config.pdf, _config_pdf_layout = _config_pdf.layout, layout = _config_pdf_layout === void 0 ? "landscape" : _config_pdf_layout, _config_pdf_size = _config_pdf.size, size = _config_pdf_size === void 0 ? "letter" : _config_pdf_size, _config_pdf_margin = _config_pdf.margin, margin = _config_pdf_margin === void 0 ? 0.5 : _config_pdf_margin, bleed = _config_pdf.bleed;
        docConfig = {
            layout: layout,
            size: size
        };
        doc = new PDFDocument(docConfig);
        filename = pdfname(config.filename, deckKey, out);
        cardWidthPx = config.width;
        cardHeightPx = config.height;
        if (bleed) {
            cardWidthPx = cardWidthPx - bleed * 2;
            cardHeightPx = cardHeightPx - bleed * 2;
        }
        marginPts = insToPts(margin);
        docWidth = doc.page.width;
        docHeight = doc.page.height;
        cardWidthPts = pxToPts(cardWidthPx);
        cardHeightPts = pxToPts(cardHeightPx);
        pageWidth = docWidth - marginPts * 2; // width less margin
        pageHeight = docHeight - marginPts * 2; // width less margin
        cardsPerRow = Math.floor(pageWidth / cardWidthPts);
        rowsPerPage = Math.floor(pageHeight / cardHeightPts);
        rows = _.chunk(pngBuffers, cardsPerRow);
        pages = _.chunk(rows, rowsPerPage);
        trimLines = config.pdf.trim_lines;
        // Do layout
        return [
            2,
            new Promise(function(res, err) {
                var pdfStream = fs.createWriteStream(filename);
                try {
                    doc.pipe(pdfStream);
                    // Iterate Pages
                    _.forEach(pages, function(rows, i) {
                        if (i > 0) doc.addPage();
                        // Iterate Rows
                        _.forEach(rows, function(row, j) {
                            var y = j * cardHeightPts + marginPts;
                            if (trimLines) {
                                drawTrimLine(doc, 0, y, docWidth, y);
                            }
                            // Iterate Cards
                            _.forEach(row, function(card, k) {
                                var x = k * cardWidthPts + marginPts;
                                if (trimLines) {
                                    drawTrimLine(doc, x, 0, x, docHeight);
                                }
                                doc.image(card, x, y, {
                                    width: cardWidthPts,
                                    height: cardHeightPts
                                });
                                // Last Card in Row
                                if (k + 1 === row.length) {
                                    var finalX = x + cardWidthPts;
                                    if (trimLines) {
                                        drawTrimLine(doc, finalX, 0, finalX, docHeight);
                                    }
                                }
                            });
                            // Last Row on Page
                            if (j + 1 === rows.length) {
                                var finalY = y + cardHeightPts;
                                if (trimLines) {
                                    drawTrimLine(doc, 0, finalY, docWidth, finalY);
                                }
                            }
                        });
                    });
                    doc.end();
                } catch (e) {
                    err(e);
                }
                pdfStream.addListener("finish", res);
            })
        ];
    });
});
var drawTrimLine = function(doc, startX, startY, endX, endY) {
    doc.moveTo(startX, startY).lineWidth(0.5).lineTo(endX, endY).dash(5).stroke("#ccc");
};
