function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
        var info = gen[key](arg);
        var value = info.value;
    } catch (error) {
        reject(error);
        return;
    }
    if (info.done) {
        resolve(value);
    } else {
        Promise.resolve(value).then(_next, _throw);
    }
}
function _asyncToGenerator(fn) {
    return function() {
        var self = this, args = arguments;
        return new Promise(function(resolve, reject) {
            var gen = fn.apply(self, args);
            function _next(value) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
            }
            function _throw(err) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
            }
            _next(undefined);
        });
    };
}
function _extends() {
    _extends = Object.assign || function(target) {
        for(var i = 1; i < arguments.length; i++){
            var source = arguments[i];
            for(var key in source){
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }
        return target;
    };
    return _extends.apply(this, arguments);
}
var __generator = this && this.__generator || function(thisArg, body) {
    var f, y, t, g, _ = {
        label: 0,
        sent: function() {
            if (t[0] & 1) throw t[1];
            return t[1];
        },
        trys: [],
        ops: []
    };
    return g = {
        next: verb(0),
        "throw": verb(1),
        "return": verb(2)
    }, typeof Symbol === "function" && (g[Symbol.iterator] = function() {
        return this;
    }), g;
    function verb(n) {
        return function(v) {
            return step([
                n,
                v
            ]);
        };
    }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while(_)try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [
                op[0] & 2,
                t.value
            ];
            switch(op[0]){
                case 0:
                case 1:
                    t = op;
                    break;
                case 4:
                    _.label++;
                    return {
                        value: op[1],
                        done: false
                    };
                case 5:
                    _.label++;
                    y = op[1];
                    op = [
                        0
                    ];
                    continue;
                case 7:
                    op = _.ops.pop();
                    _.trys.pop();
                    continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                        _ = 0;
                        continue;
                    }
                    if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
                        _.label = op[1];
                        break;
                    }
                    if (op[0] === 6 && _.label < t[1]) {
                        _.label = t[1];
                        t = op;
                        break;
                    }
                    if (t && _.label < t[2]) {
                        _.label = t[2];
                        _.ops.push(op);
                        break;
                    }
                    if (t[2]) _.ops.pop();
                    _.trys.pop();
                    continue;
            }
            op = body.call(thisArg, _);
        } catch (e) {
            op = [
                6,
                e
            ];
            y = 0;
        } finally{
            f = t = 0;
        }
        if (op[0] & 5) throw op[1];
        return {
            value: op[0] ? op[1] : void 0,
            done: true
        };
    }
};
import _ from "lodash";
import { join, resolve } from "path";
import React from "react";
import * as ReactDOMServer from "react-dom/server";
import rimraf from "rimraf";
import { DeckProvider } from "../../components/DeckContext.js";
import { TEMPLATE_FOLDER, TMP_FOLDER } from "./constants.js";
import fsp from "./utils/fsp.js";
import { verboseLog } from "./utils/logger.js";
import { transformDir } from "./utils/transform.js";
export var renderTemplates = /*#__PURE__*/ _asyncToGenerator(function(projectRoot, config, data) {
    var renderings, templatesPath, tmpPath, _tmp, _tmp1, _i, deckKey, deckConfig, deckData;
    return __generator(this, function(_state) {
        switch(_state.label){
            case 0:
                renderings = {};
                templatesPath = join(projectRoot, TEMPLATE_FOLDER);
                tmpPath = join(projectRoot, TMP_FOLDER);
                return [
                    4,
                    transpileTemplates(templatesPath, tmpPath)
                ];
            case 1:
                _state.sent();
                _tmp = [];
                for(_tmp1 in config)_tmp.push(_tmp1);
                _i = 0;
                _state.label = 2;
            case 2:
                if (!(_i < _tmp.length)) return [
                    3,
                    5
                ];
                deckKey = _tmp[_i];
                deckConfig = config[deckKey];
                deckData = data[deckKey];
                return [
                    4,
                    renderTemplate(tmpPath, deckConfig.template, deckConfig, deckData)
                ];
            case 3:
                renderings[deckKey] = _state.sent();
                _state.label = 4;
            case 4:
                _i++;
                return [
                    3,
                    2
                ];
            case 5:
                rimraf.sync(tmpPath);
                return [
                    2,
                    renderings
                ];
        }
    });
});
var transpileTemplates = /*#__PURE__*/ _asyncToGenerator(function(projectRoot, tmpPath) {
    var config, e;
    return __generator(this, function(_state) {
        switch(_state.label){
            case 0:
                config = {};
                _state.label = 1;
            case 1:
                _state.trys.push([
                    1,
                    3,
                    ,
                    4
                ]);
                return [
                    4,
                    fsp.readJson(join(projectRoot, ".swcrc"))
                ];
            case 2:
                config = _state.sent();
                return [
                    3,
                    4
                ];
            case 3:
                e = _state.sent();
                verboseLog("... Error loading .swcrc: " + e);
                return [
                    3,
                    4
                ];
            case 4:
                return [
                    4,
                    transformDir(projectRoot, tmpPath, {
                        config: config
                    })
                ];
            case 5:
                _state.sent();
                return [
                    2
                ];
        }
    });
});
var loadTemplate = function(filePath) {
    return import(filePath);
};
var renderTemplate = /*#__PURE__*/ _asyncToGenerator(function(templatesPath, templateName, config, data) {
    var documentPath, templatePath, useCustomDocument, Card, Document, _tmp, renderings;
    return __generator(this, function(_state) {
        switch(_state.label){
            case 0:
                documentPath = join(templatesPath, "__document.js");
                templatePath = join(templatesPath, templateName);
                return [
                    4,
                    fsp.exists(documentPath)
                ];
            case 1:
                useCustomDocument = _state.sent();
                return [
                    4,
                    loadTemplate(resolve(templatePath))
                ];
            case 2:
                Card = _state.sent().default;
                if (!useCustomDocument) return [
                    3,
                    4
                ];
                return [
                    4,
                    loadTemplate(resolve(documentPath))
                ];
            case 3:
                _tmp = _state.sent().default;
                return [
                    3,
                    6
                ];
            case 4:
                return [
                    4,
                    loadTemplate("../../components/__document.js")
                ];
            case 5:
                _tmp = _state.sent().default;
                _state.label = 6;
            case 6:
                Document = _tmp;
                renderings = _.map(data, function(row, i) {
                    var width = config.width, height = config.height;
                    var dom = /*#__PURE__*/ React.createElement(Document, {
                        width: width,
                        height: height
                    }, /*#__PURE__*/ React.createElement(DeckProvider, {
                        value: config
                    }, /*#__PURE__*/ React.createElement(Card, _extends({}, row, {
                        config: config,
                        deck: data,
                        cardIndex: i
                    }))));
                    var html = ReactDOMServer.renderToStaticMarkup(dom);
                    return {
                        html: html,
                        width: width,
                        height: height
                    };
                });
                return [
                    2,
                    renderings
                ];
        }
    });
});
